package tk.ecbercnl.studios.E2M;


import net.milkbowl.vault.economy.Economy;
import net.milkbowl.vault.economy.EconomyResponse;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.RegisteredServiceProvider;
import org.bukkit.plugin.java.JavaPlugin;

import tk.ecbercnl.studios.ec_conf_api.ConfigManager;
import tk.ecbercnl.studios.ec_conf_api.SimpleConfig;

public class E2M extends JavaPlugin implements Listener{
	public ConfigManager manager;
	public SimpleConfig config;
	PluginDescriptionFile pF = this.getDescription();
	 public static Economy econ = null;
	public void onDisable(){
		System.out.println("[" + "Emerald2Money 0.1_B-162" + "]" + "Disabled!");
	}
	public void onEnable(){
		if (!setupEconomy() ) {
            System.out.println("[" + "Emerald2Money 0.1_B-162" + "]" + "Vault Not Found! Disabling!");
            getServer().getPluginManager().disablePlugin(this);
            return;
        }
		System.out.println("[" + "Emerald2Money 0.1_B-162" + "]" + "Enabled!");
        //-----
        String[] logo = {
				"Emerald 2 Money",
				"By Ecbercnl(Admicos)"};
		this.manager = new ConfigManager(this);
		this.config = manager.getNewConfig("config.yml", logo);
		this.config.set("COST", 100, "Cost giving if right clicked");
		this.config.saveConfig();
		getServer().getPluginManager().registerEvents(this, this);
	}
	
	private boolean setupEconomy() {
        if (getServer().getPluginManager().getPlugin("Vault") == null) {
            return false;
        }
        RegisteredServiceProvider<Economy> rsp = getServer().getServicesManager().getRegistration(Economy.class);
        if (rsp == null) {
            return false;
        }
        econ = rsp.getProvider();
        return econ != null;
    }
   
	public void remove(Player player){
		final ItemStack itemStack = player.getItemInHand();
		final int amount = itemStack.getAmount();
		if (amount > 1) {
		itemStack.setAmount(amount - 1);
		player.setItemInHand(itemStack);
		}
		 
		if (amount == 1) {
		player.setItemInHand(null);
		}
	}
	
	@EventHandler
	public void onPlayerUse(PlayerInteractEvent event){
	    Player p = event.getPlayer();
	    if(p.hasPermission("e2m.use")){
	    if(p.getItemInHand().getType() == Material.EMERALD){
	    	int COST = this.config.getInt("COST");
	    	EconomyResponse r = econ.bankDeposit(p.getName(), COST);
	    	p.sendMessage(ChatColor.YELLOW + "[" + "Emerald2Money" + "]" + ChatColor.GREEN + "Emerald translating to money...");
	    	if(r.transactionSuccess()){
	    		//p.getInventory().setItemInHand(new ItemStack(Material.AIR));
	    		remove(p);
	    		p.sendMessage(ChatColor.YELLOW + "[" + "Emerald2Money" + "]" + ChatColor.GREEN + "Success");
	    	}
	    	else{
	    		p.sendMessage(ChatColor.YELLOW + "[" + "Emerald2Money" + "]" + ChatColor.RED + "FAILED!" + ChatColor.GRAY + "(Item is not deleted! Try Again)");
	    	}
	      }
	    }
	}
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args){
		if(cmd.getName().equalsIgnoreCase("e2m_reload")){
			sender.sendMessage(ChatColor.YELLOW + "[" + "Emerald2Money" + "]" + ChatColor.BLUE + "Reloading...");
			this.config.reloadConfig();
			sender.sendMessage(ChatColor.YELLOW + "[" + "Emerald2Money" + "]" + ChatColor.GREEN + "OK!");
		}
		return false;
	}
}
